#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int long long
#define double long double

double sqrt2 = sqrt(2);

struct pr{
    double f, s;
};

pr to_vec(pr a, pr b) {
    return {b.f - a.f, b.s - a.s};
}

double dist(pr a, pr b) {
    return (a.f - b.f) * (a.f - b.f) + (a.s - b.s) * (a.s - b.s);
}

double angle(pr a, pr b) {
    double ang = atan2(a.s, a.f) - atan2(b.s, b.f);
//    if (ang > M_PI) {
//        ang -= 2 * M_PI;
//    } else if (ang < -M_PI) {
//        ang += 2 * M_PI;
//    }
    return ang;
}

pr rot1(pr a) {
    return {a.s, -a.f};
}

pr rot2(pr a) {
    return {-a.s, a.f};
}

double crossProduct(pr v1, pr v2) {
    return v1.f * v2.s - v1.s * v2.f;
}

double vecmag(pr v) {
    return sqrt(v.f * v.f + v.s * v.s);
}

double calcsin(pr v1, pr v2) {
    double cross = crossProduct(v1, v2);
    pr nul = {0, 0};
    double mag1 = vecmag(v1);
    double mag2 = vecmag(v2);

    return cross / (mag1 * mag2);
}

double calccos(pr v1, pr v2) {
    return sqrt(1 - calcsin(v1, v2) * calcsin(v1, v2));
}



double getmin(pr a, pr b, pr c) {
//    double d = sqrt(dist(a, b));
//    double hyp = sqrt(dist(b, c));
//    pr ad = to_vec(a, b);
//    pr bc = to_vec(b, c);
//    ad = rot1(ad);
//    double minim = hyp * (abs(sin(angle(ad, bc))) + abs(cos(angle(ad, bc))));
//    ad = rot2(to_vec(a, b));
//    minim = min(minim, hyp * (abs(sin(angle(ad, bc))) + abs(cos(angle(ad, bc)))));
//    cout << fixed << d + minim << ' ' << d << ' ' << minim << ' ' << hyp << '\n';
//    return d + minim;
    if (dist(a, c) < dist(a, b)) return 1e9;
    pr ac = to_vec(a, c);
    pr ab = to_vec(a, b);
    double ang = angle(ab, ac);
    if (dist(b, c) == dist(a, b) + dist(a, c)) return 1e9;
    double C = sqrt(dist(a, c));
    double A = abs(calccos(ab, ac) * C);
    double B = abs(calcsin(ab, ac) * C);
//    if (calccos(ab, ac)) A = 1e9;
//    if (B < 1e-7) B = 1e9;
//    if (C < 1e-7) C = 1e9;
//    cout  << A << ' ' << B << ' ' << C << '\n';
    return min({A + B, A + C, B + C});
}



void solve() {
    int n;
    cin >> n;
    vector<pr> vec(n);
    for (int i = 0; i < n; i++) {
        cin >> vec[i].f >> vec[i].s;
    }
    if (n == 2) {
        double ans = sqrt(dist(vec[0], vec[1]));
        cout << fixed << ans << '\n';
    } else if (n == 3) {
        double ans = getmin(vec[0], vec[1], vec[2]);
        ans = min(ans, getmin(vec[1], vec[0], vec[2]));

        ans = min(ans, getmin(vec[0], vec[2], vec[1]));
        ans = min(ans, getmin(vec[2], vec[0], vec[1]));

        ans = min(ans, getmin(vec[1], vec[2], vec[0]));
        ans = min(ans, getmin(vec[2], vec[1], vec[0]));
        cout << setprecision(10) << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int z = 1;
//    cin >> z;
    while (z--) {
        solve();;
    }
}
