#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define int long long
#define double long double

double sqrt2 = sqrt(2);

struct pr{
    double f, s;
};

pr to_vec(pr a, pr b) {
    return {b.f - a.f, b.s - a.s};
}

double dist(pr a, pr b) {
    return (a.f - b.f) * (a.f - b.f) + (a.s - b.s) * (a.s - b.s);
}

double angle(pr a, pr b) {
    double ang = atan2(a.s, a.f) - atan2(b.s, b.f);
    if (ang > M_PI) {
        ang -= 2 * M_PI;
    } else if (ang < -M_PI) {
        ang += 2 * M_PI;
    }
    return ang;
}

pr rot1(pr a) {
    return {a.s, -a.f};
}

pr rot2(pr a) {
    return {-a.s, a.f};
}



double getmin(pr a, pr b, pr c) {
    double d = sqrt(dist(a, b));
    double hyp = sqrt(dist(b, c));
    pr ad = to_vec(a, b);
    pr bc = to_vec(b, c);
    ad = rot1(ad);
    double minim = hyp * (abs(sin(angle(ad, bc))) + abs(cos(angle(ad, bc))));
    ad = rot2(to_vec(a, b));
    minim = min(minim, hyp * (abs(sin(angle(ad, bc))) + abs(cos(angle(ad, bc)))));
//    cout << fixed << d + minim << ' ' << d << ' ' << minim << ' ' << hyp << '\n';
    return d + minim;
}

void solve() {
    int n;
    cin >> n;
    vector<pr> vec(n);
    for (int i = 0; i < n; i++) {
        cin >> vec[i].f >> vec[i].s;
    }
    if (n == 2) {
        double ans = sqrt(dist(vec[0], vec[1]));
        cout << fixed << ans << '\n';
    } else if (n == 3) {
        double ans = getmin(vec[0], vec[1], vec[2]);
        ans = min(ans, getmin(vec[1], vec[0], vec[2]));

        ans = min(ans, getmin(vec[0], vec[2], vec[1]));
        ans = min(ans, getmin(vec[2], vec[0], vec[1]));

        ans = min(ans, getmin(vec[1], vec[2], vec[0]));
        ans = min(ans, getmin(vec[2], vec[1], vec[0]));
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int z = 1;
//    cin >> z;
    while (z--) {
        solve();;
    }
}
